nova-manage db migrate_flavor_data doesn't do instances not in instance_extra

Bug #1447132 reported by Joshua Hesketh on 2015-04-22
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
High
Dan Smith
Kilo
High
Unassigned

Bug Description

nova-manage db migrate_flavor_data selects all of the instances by joining them to the instance_extra table and then checks which ones have flavor information in the metadata table or the extras table. However, if an instance isn't in instance_extra (for example, it hasn't been written to since the creation of the extras table) then it won't be migrated (even if it isn't deleted AND has flavor info in the metadata table).

migrate_flavor_data should select all of the instances in the metadata table with flavor information and migrate those.

Matt Riedemann (mriedem) on 2015-04-22
tags: added: db
Matt Riedemann (mriedem) on 2015-04-22
Changed in nova:
importance: Undecided → High
status: New → Triaged
tags: added: kilo-backport-potential
Changed in nova:
assignee: nobody → Dan Smith (danms)
status: Triaged → In Progress
Dan Smith (danms) wrote :

Reviewed: https://review.openstack.org/176387
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=92714accc49e85579f406de10ef8b3b510277037
Submitter: Jenkins
Branch: master

commit 92714accc49e85579f406de10ef8b3b510277037
Author: Dan Smith <email address hidden>
Date: Wed Apr 22 09:02:03 2015 -0700

    Fix migrate_flavor_data() to catch instances with no instance_extra rows

    The way the query was being performed previously, we would not see any
    instances that didn't have a row in instance_extra. This could happen if
    an instance hasn't been touched for several releases, or if the data
    set is old.

    The fix is a simple change to use outerjoin instead of join. This patch
    includes a test that ensures that instances with no instance_extra rows
    are included in the migration. If we query an instance without such a
    row, we create it before doing a save on the instance.

    Closes-Bug: #1447132
    Change-Id: I2620a8a4338f5c493350f26cdba3e41f3cb28de7

Changed in nova:
status: In Progress → Fix Committed
Dan Smith (danms) wrote :

Marking this as kilo-rc-potential because if we do an RC3, we should put this into it. However, we shouldn't justify rc3 with it.

tags: added: kilo-rc-potential
Thierry Carrez (ttx) on 2015-04-28
no longer affects: nova/kilo

Reviewed: https://review.openstack.org/176741
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=a2872a9262985bd0ee2c6df4f7593947e0516406
Submitter: Jenkins
Branch: stable/kilo

commit a2872a9262985bd0ee2c6df4f7593947e0516406
Author: Dan Smith <email address hidden>
Date: Wed Apr 22 09:02:03 2015 -0700

    Fix migrate_flavor_data() to catch instances with no instance_extra rows

    The way the query was being performed previously, we would not see any
    instances that didn't have a row in instance_extra. This could happen if
    an instance hasn't been touched for several releases, or if the data
    set is old.

    The fix is a simple change to use outerjoin instead of join. This patch
    includes a test that ensures that instances with no instance_extra rows
    are included in the migration. If we query an instance without such a
    row, we create it before doing a save on the instance.

    Closes-Bug: #1447132
    Change-Id: I2620a8a4338f5c493350f26cdba3e41f3cb28de7
    (cherry picked from commit 92714accc49e85579f406de10ef8b3b510277037)

Thierry Carrez (ttx) on 2015-04-30
tags: removed: kilo-rc-potential
Download full text (18.1 KiB)

Reviewed: https://review.openstack.org/179284
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=5228d4e418734164ffa5ccd91d2865d9cc659c00
Submitter: Jenkins
Branch: master

commit 906ab9d6522b3559b4ad36d40dec3af20397f223
Author: He Jie Xu <email address hidden>
Date: Thu Apr 16 07:09:34 2015 +0800

    Update rpc version aliases for kilo

    Update all of the rpc client API classes to include a version alias
    for the latest version implemented in Kilo. This alias is needed when
    doing rolling upgrades from Kilo to Liberty. With this in place, you can
    ensure all services only send messages that both Kilo and Liberty will
    understand.

    Closes-Bug: #1444745

    Conflicts:
     nova/conductor/rpcapi.py

    NOTE(alex_xu): The conflict is due to there are some logs already added
    into the master.

    Change-Id: I2952aec9aae747639aa519af55fb5fa25b8f3ab4
    (cherry picked from commit 78a8b5802ca148dcf37c5651f75f2126d261266e)

commit f191a2147a21c7e50926b288768a96900cf4c629
Author: Hans Lindgren <email address hidden>
Date: Fri Apr 24 13:10:39 2015 +0200

    Add security group calls missing from latest compute rpc api version bump

    The recent compute rpc api version bump missed out on the security group
    related calls that are part of the api.

    One possible reason is that both compute and security group client side
    rpc api:s share a single target, which is of little value and only cause
    mistakes like this.

    This change eliminates future problems like this by combining them into
    one to get a 1:1 relationship between client and server api:s.

    Change-Id: I9207592a87fab862c04d210450cbac47af6a3fd7
    Closes-Bug: #1448075
    (cherry picked from commit bebd00b117c68097203adc2e56e972d74254fc59)

commit a2872a9262985bd0ee2c6df4f7593947e0516406
Author: Dan Smith <email address hidden>
Date: Wed Apr 22 09:02:03 2015 -0700

    Fix migrate_flavor_data() to catch instances with no instance_extra rows

    The way the query was being performed previously, we would not see any
    instances that didn't have a row in instance_extra. This could happen if
    an instance hasn't been touched for several releases, or if the data
    set is old.

    The fix is a simple change to use outerjoin instead of join. This patch
    includes a test that ensures that instances with no instance_extra rows
    are included in the migration. If we query an instance without such a
    row, we create it before doing a save on the instance.

    Closes-Bug: #1447132
    Change-Id: I2620a8a4338f5c493350f26cdba3e41f3cb28de7
    (cherry picked from commit 92714accc49e85579f406de10ef8b3b510277037)

commit e3a7b83834d1ae2064094e9613df75e3b07d77cd
Author: OpenStack Proposal Bot <email address hidden>
Date: Thu Apr 23 02:18:41 2015 +0000

    Updated from global requirements

    Change-Id: I5d4acd36329fe2dccb5772fed3ec55b442597150

commit 8c9b5e620eef3233677b64cd234ed2551e6aa182
Author: Divya <email address hidden>
Date: Tue Apr 21 08:26:29 2015 +0200

    Control create/delete flavor api permissions using policy.json

    The permissions of ...

Reviewed: https://review.openstack.org/176955
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=3b6a6b0da8753192c37dbca6d1f79c666385898c
Submitter: Jenkins
Branch: master

commit 3b6a6b0da8753192c37dbca6d1f79c666385898c
Author: Dan Smith <email address hidden>
Date: Thu Apr 23 12:47:20 2015 -0700

    Add some testing for flavor migrations with deleted things

    This just tries to further cover the migrate_flavor_data() method with
    some additional scenarios of deleted instances, deleted system metadata, etc.

    Change-Id: I433dc4f3791b39b2f6d6ee4d197057257be947e1
    Related-Bug: #1447132

Thierry Carrez (ttx) on 2015-06-24
Changed in nova:
milestone: none → liberty-1
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2015-10-15
Changed in nova:
milestone: liberty-1 → 12.0.0
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers